<?php
/**
* @version		$Id: helper.php 2007-11-25 kamilwais $
* @package		Joomla
* @copyright		Copyright (C) 2007 - 2008 Kamil Wais. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

class modVisitCounterHelper
{
	function render(&$params)
	{
		// Read our Parameters
		$today			=	@$params->get('today', 'Today');
		$yesterday		=	@$params->get('yesterday', 'Yesterday');
		$daybeforeyesterday		=	@$params->get('daybeforeyesterday', 'Day before yesterday');
		$x_month		=	@$params->get('month', 'This month');
		$x_last_month		=	@$params->get('last_month', 'Last month');
		$x_monthbeforelastmonth =	@$params->get('monthbeforelastmonth', 'Month before last month');
		$x_week			=	@$params->get('week', 'This week');
		$x_last_week			=	@$params->get('last_week', 'This week');
		$x_weekbeforelastweek =	@$params->get('weekbeforelastweek', 'Week before last week');
		$x_year			=	@$params->get('year', 'This year');
		$x_last_year			=	@$params->get('last_year', 'Last year');

		$x_all			=	@$params->get('all', 'Since module start');
		$x_all_1			=	@$params->get('all_1', 'Since ..........');
		$x_all_2			=	@$params->get('all_2', 'Since ..........');
		
		$x_visits			=	@$params->get('visits', 'Visits');
		$x_all_visits			=	@$params->get('all_visits', 'All visits');
		$x_avarage			=	@$params->get('avarage', 'Avarage');

		$locktime		=	@$params->get('locktime', 60);
		$initialvalue_1	=	@$params->get('initialvalue_1', 0);
		$initialvalue_2	=	@$params->get('initialvalue_2', 0);
		$records		=	@$params->get('records', 1);
		
		$s_today		=	@$params->get('s_today', 1);
		$s_yesterday	=	@$params->get('s_yesterday', 1);
		$s_week			=	@$params->get('s_week', 1);
		$s_avarage_week			=	@$params->get('s_avarage_week', 1);
		$s_month		=	@$params->get('s_month', 1);
		$s_avarage_month		=	@$params->get('s_avarage_month', 1);
		$s_year		=	@$params->get('s_year', 1);
		$s_avarage_year		=	@$params->get('s_avarage_year', 1);
		$s_all			=	@$params->get('s_all', 1);
		$s_all_1			=	@$params->get('s_all_1', 1);
		$s_all_2			=	@$params->get('s_all_2', 1);
		$s_footer			=	@$params->get('s_footer', 1);
		
		$font_color = @$params->get('font_color', '#CCCCCC');
		// From minutes to seconds
		$locktime		=	$locktime * 60;
	
		$db		=& JFactory::getDBO();
		// Check if table exists. When not, create it
		
		$query	=	"CREATE TABLE IF NOT EXISTS #__kwvisitstat (id int(11) unsigned NOT NULL auto_increment, tm int not null, ip varchar(16) not null default '0.0.0.0', PRIMARY KEY (id)) ENGINE=MyISAM AUTO_INCREMENT=1";
		$db->setQuery($query);
		$db->query();
		
		// Now we are checking if the ip was logged in the database. Depending of the value in minutes in the locktime variable.
		$day			 =	date('d');
		$month			 =	date('n');
		$year			 =	date('Y');

		$daystart		 =	mktime(0,0,0,$month,$day,$year);
		$monthstart		 =  mktime(0,0,0,$month,1,$year);
		$yearstart = mktime(0,0,0,1,1,$year);
		
		// weekstart
		$weekday		 =	date('w');
		$weekday--;
		if ($weekday < 0)$weekday = 7;
      $weekday_today = $weekday;
		$weekday		 =	$weekday * 24*60*60;

		$weekstart		 =	$daystart - $weekday;
		$last_weekstart = $weekstart - (7*24*60*60);
		$weekbeforelastweekstart		 =	$last_weekstart - (7*24*60*60);
		

//		$yesterdaystart	 =	$daystart - (24*60*60);
		$yesterdaystart		 =	mktime(0,0,0,$month,($day-1),$year);
		$daybeforeyesterdaystart		 =	mktime(0,0,0,$month,($day-2),$year);
		
		$last_monthstart = mktime(0,0,0,($month-1),1,$year);
		$monthbeforelastmonthstart = mktime(0,0,0,($month-2),1,$year);
		$last_yearstart = mktime(0,0,0,1,1,($year-1));

		
// rednio w roku		
		
		$query			 =	"SELECT MIN(tm) FROM #__kwvisitstat";
							$db->setQuery($query);
		$min_tm	 =	$db->loadResult();

      $day_of_year = (mktime(0,0,0,date('n'),date('d'),date('Y'))-$min_tm)/(60*60*24);


		
  		//		$last_monthstart = $monthstart - (30*24*60*60);

		$now			 =	time();
		$ip				 =	$_SERVER['REMOTE_ADDR'];
		
		$query			 =	"SELECT MAX(id) FROM #__kwvisitstat";
							$db->setQuery($query);
		$all_visitors	 =	$db->loadResult();
		
		$query			 =	"SELECT MIN(id) FROM #__kwvisitstat";
							$db->setQuery($query);
		$all_visitors_min	 =	$db->loadResult();
		
		// Delete old records
		$temp=$all_visitors-$records;
		
		if ($temp>0){
			$query		 =  "DELETE FROM #__kwvisitstat WHERE id<'$temp'";
							$db->setQuery($query);
							$db->query();
		}
		
		
		$query			 =	"SELECT COUNT(*) FROM #__kwvisitstat WHERE ip='$ip' AND (tm+'$locktime')>'$now'";
							$db->setQuery($query);
		$items			 =	$db->loadResult();
		
		if (empty($items))
		{
			$query = "INSERT INTO #__kwvisitstat (id, tm, ip) VALUES ('', '$now', '$ip')";
			$db->setQuery($query);
			$db->query();
			$e = $db->getErrorMsg();
		}
		
		$n				 = 	$all_visitors;
		$div = 100000;
		while ($n > $div) {
			$div *= 10;
		}

		
// statystyki - zapytania do bazy
		
		$query			 =	"SELECT COUNT(*) FROM #__kwvisitstat WHERE tm>'$daystart'";
							$db->setQuery($query);
		$today_visitors	 =	$db->loadResult();

		$query			 =	"SELECT COUNT(*) FROM #__kwvisitstat WHERE tm>'$yesterdaystart' and tm<'$daystart'";
							$db->setQuery($query);
		$yesterday_visitors	 =	$db->loadResult();
			
		$query			 =	"SELECT COUNT(*) FROM #__kwvisitstat WHERE tm>'$daybeforeyesterdaystart' and tm<'$yesterdaystart'";
							$db->setQuery($query);
		$daybeforeyesterday_visitors	 =	$db->loadResult();
			



		$query			 =	"SELECT COUNT(*) FROM #__kwvisitstat WHERE tm>='$weekstart'";
							$db->setQuery($query);
		$week_visitors	 =	$db->loadResult();

		$query			 =	"SELECT COUNT(*) FROM #__kwvisitstat WHERE tm>'$last_weekstart' and tm<'$weekstart'";
							$db->setQuery($query);
		$last_week_visitors	 =	$db->loadResult();

		$query			 =	"SELECT COUNT(*) FROM #__kwvisitstat WHERE tm>'$weekbeforelastweekstart' and tm<'$last_weekstart'";
							$db->setQuery($query);
		$weekbeforelastweek_visitors	 =	$db->loadResult();
			



		$query			 =	"SELECT COUNT(*) FROM #__kwvisitstat WHERE tm>='$monthstart'";
							$db->setQuery($query);
		$month_visitors	 =	$db->loadResult();

		$query			 =	"SELECT COUNT(*) FROM #__kwvisitstat WHERE tm>='$last_monthstart' and tm<'$monthstart'";
							$db->setQuery($query);
		$last_month_visitors	 =	$db->loadResult();

		$query			 =	"SELECT COUNT(*) FROM #__kwvisitstat WHERE tm>'$monthbeforelastmonthstart' and tm<'$last_monthstart'";
							$db->setQuery($query);
		$monthbeforelastmonth_visitors	 =	$db->loadResult();
			




		$query			 =	"SELECT COUNT(*) FROM #__kwvisitstat WHERE tm>='$yearstart'";
							$db->setQuery($query);
		$year_visitors	 =	$db->loadResult();

		$query			 =	"SELECT COUNT(*) FROM #__kwvisitstat WHERE tm>'$last_yearstart' and tm <'$yearstart'";
							$db->setQuery($query);
		$last_year_visitors	 =	$db->loadResult();

		
		$content = '<div>';
		
		$content		 .=	'<div><table cellpadding="0" cellspacing="0" style="text-align: center; font-size: 0.8em; width: 100%;  " class="vinaora_counter"><tbody align="center" >';

		// Show today, yestoday, week, month, all statistic
   $content .=  '<tr ><td align="left" style="font-size: 1em; font-weight: bold; ">'.$x_visits.'</td><td align="right" style="font-size: 1em; font-weight: bold"> </td><td align="right" style="font-size: 0.8em; font-weight: bold; color: '.$font_color.'">[+/-]</td></tr>';
//   '.$all_visitors_min.'/92;

// statystyki dzienne
$zmiana=$yesterday_visitors-$daybeforeyesterday_visitors;
if($zmiana>=0){ 
$zmiana='+'.$zmiana; 
}
if($s_today)       $content .=  '<tr><td align="right" style="border-bottom:1px dashed #D8E0DF;" ><b>'.$today.':</b><br/>'.$yesterday.':<br>'.$daybeforeyesterday.': </td><td align="right" style="border-bottom:1px dashed #D8E0DF;"><b>'.$today_visitors.'</b><br/>'.$yesterday_visitors.'<br>'.$daybeforeyesterday_visitors.'</td><td align="right" style="font-size: 1.2em; font-weight: bold; padding-left: 4px; border-bottom:1px dashed #D8E0DF;  color: '.$font_color.'"><br>'.($zmiana).'</td></tr>';


// statystyki tygodniowe
$zmiana=$last_week_visitors-$weekbeforelastweek_visitors;
if($zmiana>=0){ 
$zmiana='+'.$zmiana; 
}
if($s_week)       $content .=  '<tr><td align="right" style="border-bottom:1px dashed #D8E0DF;" ><b>'.$x_week.':</b><br/>'.$x_last_week.':<br>'.$x_weekbeforelastweek.': </td><td align="right" style="border-bottom:1px dashed #D8E0DF;"><b>'.$week_visitors.'</b><br/>'.$last_week_visitors.'<br>'.$weekbeforelastweek_visitors.'</td><td align="right" style="font-size: 1.2em; font-weight: bold; padding-left: 4px;border-bottom:1px dashed #D8E0DF;  color: '.$font_color.'"><br>'.($zmiana).'</td></tr>';

// statystyki miesiczne
$zmiana=$last_month_visitors-$monthbeforelastmonth_visitors;
if($zmiana>=0){ 
$zmiana='+'.$zmiana; 
}
if($s_month)       $content .=  '<tr><td align="right" style="border-bottom:1px dashed #D8E0DF;" ><b>'.$x_month.':</b><br/>'.$x_last_month.':<br>'.$x_monthbeforelastmonth.':</td><td align="right" style="border-bottom:1px dashed #D8E0DF;"><b>'.$month_visitors.'</b><br/>'.$last_month_visitors.'<br>'.$monthbeforelastmonth_visitors.'</td><td align="right" style="font-size: 1.2em; font-weight: bold; padding-left: 4px;border-bottom:1px dashed #D8E0DF;  color: '.$font_color.'"><br/>'.($zmiana).'</td></tr>';


//statystyki roczne
$zmiana=$year_visitors-$last_year_visitors;
if($zmiana>=0){ 
$zmiana='+'.$zmiana; 
}
if($s_year)       $content .=  '<tr><td align="right" style="border-bottom:1px dashed #D8E0DF;" ><b>'.$x_year.':</b><br/>'.$x_last_year.':</td><td align="right" style="border-bottom:1px dashed #D8E0DF;"><b>'.$year_visitors.'</b><br/>'.$last_year_visitors.'</td><td align="right" style="font-size: 1.2em; font-weight: bold; padding-left: 4px;border-bottom:1px dashed #D8E0DF;  color: '.$font_color.'">'.($zmiana).'</td></tr>';


// statystyki rednie
// statystyki rednio dzienne
		  
if(($s_avarage_week)or($s_avarage_month)) {
  $content .=  '<tr><td align="left"><br><b>'.$x_avarage.'</b></td><td></td><td></td></tr>';
}

//tygodniowe
$zmiana=(round(($week_visitors/($weekday_today+1)),1))-(round(($last_week_visitors/7),1));
if($zmiana>=0){ 
$zmiana='+'.$zmiana; 
}
$zmiana2=(round(($last_week_visitors/7),1))-(round(($weekbeforelastweek_visitors/7),1));
if($zmiana2>=0){ 
$zmiana2='+'.$zmiana2; 
}
if($s_avarage_week)          $content .=  '<tr><td align="right" style="border-bottom:1px dashed #D8E0DF;" ><b>'.$x_week.':</b><br/>'.$x_last_week.':<br>'.$x_weekbeforelastweek.':</td><td align="right" style="border-bottom:1px dashed #D8E0DF;"><b>'.(round(($week_visitors/($weekday_today+1)),1)).'</b><br/>'.(round(($last_week_visitors/7),1)).'<br>'.(round($weekbeforelastweek_visitors/7,1)).'</td><td align="right" style="font-size: 1.2em; color: '.$font_color.'; font-weight: bold; padding-left: 4px;border-bottom:1px dashed #D8E0DF;">'.($zmiana).'<br>'.$zmiana2.'</td></tr>';

//statystyki rednie miesiczne
$zmiana=((round(($month_visitors/$day),1))-(round(($last_month_visitors/30),1)));
if($zmiana>=0){ 
$zmiana='+'.$zmiana; 
}
$zmiana2=(round(($last_month_visitors/30),1))-(round(($monthbeforelastmonth_visitors/30),1));
if($zmiana2>=0){ 
$zmiana2='+'.$zmiana2; 
}
if($s_avarage_month)         $content .=  '<tr><td align="right" style="border-bottom:1px dashed #D8E0DF;" ><b>'.$x_month.':</b><br/>'.$x_last_month.':<br/>'.$x_monthbeforelastmonth.':</td><td align="right" style="border-bottom:1px dashed #D8E0DF;"><b>'.(round(($month_visitors/$day),1)).'</b><br/>'.(round(($last_month_visitors/30),1)).'<br/>'.(round(($monthbeforelastmonth_visitors/30),1)).'</td><td align="right" style="font-size: 1.2em; font-weight: bold; padding-left: 4px;border-bottom:1px dashed #D8E0DF; color: '.$font_color.'">'.($zmiana).'<br/>'.$zmiana2.'</td></tr>';

//statystyki rednie roczne

$zmiana=((round(($year_visitors/$day_of_year),1))-(round(($last_year_visitors/365),1)));
if($zmiana>=0){ 
$zmiana='+'.$zmiana; 
}
if($s_avarage_year)         $content .=  '<tr><td align="right" style="border-bottom:1px dashed #D8E0DF;" ><b>'.$x_year.':</b><br/>'.$x_last_year.':</b></td><td align="right" style="border-bottom:1px dashed #D8E0DF;"><b>'.(round(($year_visitors/$day_of_year),1)).'</b><br/>'.(round(($last_year_visitors/365),1)).'</td><td align="right" style="font-size: 1.2em; font-weight: bold; padding-left: 4px;border-bottom:1px dashed #D8E0DF; color: '.$font_color.'">'.$zmiana.'</td></tr>';



//liczniki
if(($s_all)or($s_all_1)or($s_all_2)) {
       $content .=  '<tr><td align="left"><br><b>'.$x_all_visits.'</b></td><td></td><td></td></tr>';
}
		if ($all_visitors == NULL) {
			$all_visitors = $initialvalue_1;
		} else {
//			$all_visitors += $initialvalue_2;
		}

if($s_all)              $content .=  '<tr><td align="left" colspan="1"  style="border-bottom:1px dashed #D8E0DF;">'.$x_all.' </td><td align="right" style="font-size: 1.2em; font-weight: bold; border-bottom:1px dashed #D8E0DF; "  style="border-bottom:1px dashed #D8E0DF;" colspan="2">'.(number_format(($all_visitors), 0, '', ' ')).'</td></tr>';
if($s_all_1)              $content .=  '<tr><td align="left" colspan="1">'.$x_all_1.' </td><td align="right" style="font-size: 1.2em; font-weight: bold;" colspan="2">'.(number_format(($all_visitors+$initialvalue_1), 0, '', ' ')).'</td></tr>';
if($s_all_2)   $content .=  '<tr><td align="left" colspan="1"><b>'.$x_all_2.' </b></td><td align="right" style="font-size: 2em; font-weight: bold; font-family: Helvetica, Arial,Verdana; background-color: white; border:1px dashed #CCCCCC;" colspan="2">&nbsp;&nbsp;'.(number_format(($all_visitors+$initialvalue_2), 0, '', ' '))."&nbsp;";
		

      $content .=  '</td></tr>';	
		$content		.= "</tbody></table></div>";
if($s_footer) $content .=  '<div style="font-size: 0.8em; color: #CCCCCC; text-align: center; padding: 5px 0 0 0; margin: 5px 0 0 0;"><a target="_parent" onfocus="blur(this)" href="http://www.wais.kamil.rzeszow.pl">KW Visitors Statistics</a></div>'; else {

	}
		$content .= "</div>";
		echo $content;
	}
}